Provides a dynamic admin interface for your Doctrine ORM entities in your symfony2 project.

## Requirements

 * ExtJS > 3.2 at web/vendor/extjs.

## Installation

### Add ExtJSAdminBundle to your project.

    git submodule add git://github.com/trapp/ExtJSAdminBundle.git src/trapp/ExtJSAdminBundle

### Add the trapp namespace to your autoload.php

    // app/autoload.php
    $loader->registerNamespaces(array(
        'trapp' => __DIR__ . '/../src',
        // your other namespaces
    );

### Add ExtJSAdminBundle to your application kernel

    // app/AppKernel.php
    public function registerBundles()
    {
        return array(
            // ...
            new trapp\ExtJSAdminBundle\ExtJSAdminBundle(),
            // ...
        );
    }

### Add the needed routes.

    // app/config/routing.yml
    extjs_admin:
        resource: "@ExtJSAdminBundle/Resources/config/routing.yml"

### Add a symbolic link for the web files.

    cd web/bundles
    ln -s ../../src/trapp/ExtJSAdminBundle/Resources/web extjs_admin

### Enjoy it.

#### Open the following url to see it in action.

    /admin

### Todo

Most neccessary features are working. It is still under development and this is just a preview release.

I will publish an howto regarding creating own edit views here soon.
