Ext.ns("Symfony.Bundle.AdminBundle");
objectStore = {};

Ext.onReady(function() {
    Ext.QuickTips.init(); 
    // invalid markers to sides
    Ext.form.Field.prototype.msgTarget = 'side';
});

Symfony.Bundle.AdminBundle.pageSize = 25;

Symfony.Bundle.AdminBundle.DataType = {
    "datetime": {
        "regex": /^\d\d\d\d-\d\d-\d\d\s[012]\d:[0-5]\d:[0-5]\d$/,
        "msg": "Has to be in the format YYYY-MM-DD HH:MM:SS."
    },
    "date": {
        "regex": /^\d\d\d\d-\d\d-\d\d\d$/,
        "msg": "Has to be in the format YYYY-MM-DD."
    },
    "time": {
        "regex": /^[012]\d:[0-5]\d:[0-5]\d$/,
        "msg": "Has to be in the format HH:MM:SS."
    },
    "numeric": {
        "regex": /^\d+$/,
        "msg": "Has to be numeric."
    },
    "float": {
        "regex": /^\d+\.?\d*$/,
        "msg": "Has to be something like 5 or 2.7"
    }
};

Symfony.Bundle.AdminBundle.DataType.integer = Symfony.Bundle.AdminBundle.DataType.numeric;
Symfony.Bundle.AdminBundle.DataType.smallint = Symfony.Bundle.AdminBundle.DataType.numeric;
Symfony.Bundle.AdminBundle.DataType.bigint = Symfony.Bundle.AdminBundle.DataType.numeric;
Symfony.Bundle.AdminBundle.DataType.decimal = Symfony.Bundle.AdminBundle.DataType["float"];



Symfony.Bundle.AdminBundle.defaultList = Ext.extend(Ext.Panel,{
    myRenderers: {}
    ,initComponent: function(){
        // Called during component initialization
        var data = this.node.attributes.data;


        var fields = [];
        var columns = [];
        var formFields = [];
        var self = this;
        var identifierName = entityMap[self.node.attributes.id]['identifier'];
        
        for (var obj in data.fieldMappings){
            delete(data.fieldMappings[obj].id);
            delete(data.fieldMappings[obj].cascade);
            fields.push(obj);
            var doRender = function(val,cell,elm) {
                return val;
            };
            var o = data.fieldMappings[obj];
            if(o.type=='ref') {
                doRender = function(val,cell,elm,row,col) {
                    if (typeof val == 'object') {

                        var targetIdentitifer = entityMap[o.targetEntity]['identifier'];

                        return val[targetIdentitifer];
                    }
                    /*var objName = grid.colModel.config[col].dataIndex;
                    if(elm.data[objName+"_cmsdisplay"]) {
                        return elm.data[objName+"_cmsdisplay"];
                    }
                    return val+" [REF]";*/
                    
                    return val;
                };
            } else if (o.type == 'datetime') {
                doRender = function(val,cell,elm,row,col) {
                    if (typeof val == 'object' && val != null) {
                        return val.date;
                    }
                    return val;
                };
            }

            var filterType = 'string';
            if(o.type=='number' || o.type=='id' || o.type=='geo') {
                filterType = 'numeric';
            } else if (o.type=='datetime') {
                filterType = 'date';
            }
            var tmp = {
                header: obj
                ,dataIndex: obj
                ,sortable: true
                ,renderer: doRender
                ,filter: {
                    type: filterType
                    // specify disabled to disable the filter menu
                    //, disabled: true
                }
            };
            
            o.fieldLabel = obj;
            o.name = obj;

            if(o.type=='ref') {
                o.xtype = 'objref';
                var tmpObj = o;
                //loadRef
                if(typeof objectStore[tmpObj['targetEntity']] == 'undefined') {
                    objectStore[tmpObj['targetEntity']] = 1;
                    //loadObjectStore(tmpObj['targetEntity'],func);
                }
            } else if (o.type=='boolean') {
                o.xtype = 'checkbox';
                o.inputValue = '1';
            } else if (o.type == 'datetime') {
                /*o.xtype = 'datefield';
                o.format = 'Y-m-d';*/
            }
            
            
            if(obj=='id') {
                tmp.width=50;
                columns.unshift(tmp);
                o.disabled = true;
                formFields.unshift(o);
            } else {
                columns.push(tmp);
                formFields.push(o);
                if(Symfony.Bundle.AdminBundle.DataType[o.type]) {
                    o.regex = Symfony.Bundle.AdminBundle.DataType[o.type].regex;
                    o.regexText = Symfony.Bundle.AdminBundle.DataType[o.type].msg;
                }
            }
        }
        var aSave = new Ext.Action({
            text: 'Hinzufügen'
            ,handler: function() {
                var id = 0;
                if(editForm.getForm().rec && typeof editForm.getForm().rec.data != "undefined") {
                    id=editForm.getForm().rec.data[identifierName];
                }
                editForm.getForm().submit({
                    url:'admin/save'
                    ,waitMsg:'Saving Data...'
                    ,submitEmptyText: false
                    ,params: {
                        _submitObject: self.node.attributes.id
                        ,_submitId: id
                    }
                    ,success: function (form, action) {
                        if(id==0) {
                            editForm.reset();
                        }
                        store.reload();
                    }
                });
            }
        });

        var aReset = new Ext.Action({
            text: 'Zurücksetzen'
            ,handler: function() {
                editForm.reset();
                grid.getSelectionModel().clearSelections();
            }
        });
        var editForm = new Ext.form.FormPanel({
            width:350
            ,classType: self['targetEntity']
            ,region:'east'
            ,collapsible: true
            ,title:'Bearbeiten'
            ,monitorValid:true
            ,items: [
                {
                    xtype: 'fieldset',
                    labelWidth: 90,
                    defaults: {width: 200, border:false},    // Default config options for child items
                    defaultType: 'textfield',
                    border: false,
                    items: formFields
                }
            ]
            ,tbar: new Ext.Toolbar({
                items: [
                    aSave
                    ,aReset
                ]
            })
            ,bbar: new Ext.Toolbar({
                items: [
                    aSave
                    ,aReset
                ]
            })
            ,listeners: {
                render: function() {
                    editForm.getForm().waitMsgTarget = editForm.getEl();
                }
            }
        });

        editForm.reset = function() {
            editForm.getForm().reset();
            delete(editForm.getForm().rec);
            aSave.setText('Hinzufügen');
        };
        this.editForm = editForm;

        var gridFilters = new Ext.ux.grid.GridFilters({
            // encode and local configuration options defined previously for easier reuse
            encode: false, // json encode the filter query
            local: false   // defaults to false (remote filtering)
            /*filters: [{
                type: 'numeric',
                dataIndex: 'id'
            }, {
                type: 'string',
                dataIndex: 'company',
                disabled: true
            }, {
                type: 'numeric',
                dataIndex: 'price'
            }, {
                type: 'date',
                dataIndex: 'date'
            }, {
                type: 'list',
                dataIndex: 'size',
                options: ['small', 'medium', 'large', 'extra large'],
                phpMode: true
            }, {
                type: 'boolean',
                dataIndex: 'visible'
            }]*/
        });

        var store = new Ext.data.JsonStore({
            url: 'admin/getData/'+escape(this.node.id)
            ,root: 'objects'
            ,totalProperty: 'total'
            ,fields: fields
            ,remoteSort: true
        });

        var aAdd = new Ext.Action({
            text: 'Add'
            ,handler: function() {
                editForm.reset();
                grid.getSelectionModel().clearSelections();
            }
        });

        var aDelete = new Ext.Action({
            text: 'Delete'
            ,disabled:true
            ,handler: function() {
                var objs = grid.getSelectionModel().getSelections();
                Ext.MessageBox.confirm('Wirklich löschen?', 'Wirklich '+objs.length+' Objekte löschen?', function(btn) {
                    if(btn=='yes') {
                        var ids=[];
                        for(var i=0; i<objs.length; i++) {
                            ids.push(objs[i][identifierName]);
                        }
                        editForm.reset();
                        Ext.Ajax.request({
                            url: 'admin/delete'
                            ,params: {
                                _submitObject: self.node.attributes.id
                                ,"_submitId[]": ids
                            }
                            ,success: function(ret) {
                                var tmp = Ext.decode(ret.responseText);
                                store.load();
                            }
                            ,failure: function(ret) {
                                var tmp = Ext.decode(ret.responseText);
                                Ext.Msg.alert('Fehler', tmp.msg);
                            }
                        });
                    }
                });
            }
        });
        store.setDefaultSort(data.identifier, 'desc');
        store.load({params:{start:0, limit:Symfony.Bundle.AdminBundle.pageSize}});
        var grid = new Ext.grid.GridPanel({
            region: 'center',
            store: store,
            border:true,
            title: 'Objektliste',
            plugins: [gridFilters],
            columns: columns,
            tbar: new Ext.Toolbar({
                plugins: [gridFilters],
                items: [
                    aAdd
                    ,aDelete
                    ,'->'
                    ,{
                        text: 'Clear Filter Data',
                        handler: function () {
                            grid.filters.clearFilters();
                        }
                    }
                ]
            })
            ,bbar: new Ext.PagingToolbar({
                pageSize: Symfony.Bundle.AdminBundle.pageSize,
                store: store,
                
                displayInfo: true,
                displayMsg: 'Show {0} - {1} of {2}',
                emptyMsg: "No objects to display"
            })
            ,sm: new Ext.grid.RowSelectionModel({
                singleSelect: false,
                listeners: {
                    rowselect: function(sm, row, rec) {
                        for (key in rec.data) {
                            if (typeof rec.data[key] == 'object' && rec.data[key] != null) {
                                type = entityMap[self.node.id].fieldMappings[key].type;
                                if (type == 'ref') {
                                    rec.data[key] = rec.data[key][entityMap[self.node.id].fieldMappings[key]['joinColumns'][0]['referencedColumnName']];
                                } else if (type == 'datetime') {
                                    rec.data[key] = rec.data[key].date;
                                }
                            }
                        }
                        editForm.getForm().loadRecord(rec);
                        editForm.getForm().rec=rec;
                        aSave.setText('Editieren');
                        var elms = editForm.getForm().items.items;
                        /*for(var i=0; i<elms.length;i++) {
                            if(elms[i].xtype && elms[i].xtype == 'objref') {
                                if(!elms[i].findRecord(elms[i].valueField || elms[i].displayField, rec.data[elms[i].hiddenName]))
                                {
                                    elms[i].setDisabled(true);
                                    var back = function (elm) {
                                        elm.store.load({
                                            params: {
                                                start:0,
                                                limit:Symfony.Bundle.AdminBundle.pageSize,
                                                query: rec.data[elm.hiddenName]
                                            }
                                            ,callback: function() {
                                                elm.setValue(elm.value);
                                                elm.setDisabled(false);
                                            }
                                            ,add: true
                                        });
                                    }(elms[i]);
                                }
                            }
                        }*/
                    }
                }
            })
            ,viewConfig: {
                autoFill: true
            }
            
        });
        grid.getSelectionModel().on('selectionchange', function(sm){
            var count = sm.getCount();
            aDelete.setDisabled(count < 1);
            if(count>1) {
                editForm.reset();
            }
        });

        var namespaceParts = this.node.id.split('\\');

        // Config object has already been applied to 'this' so properties can 
        // be overriden here or new properties (e.g. items, tools, buttons) 
        // can be added, eg:
        Ext.apply(this, {
            layout: 'border'
            ,defaults: {
                split: true
            }
            ,title: namespaceParts[1] + "\\" + namespaceParts[namespaceParts.length-1]
            ,id: 'defaultAdminCenter:'+this.node.id
            ,closable: true
            ,items: [
                grid
                ,editForm
            ]
        });
        // Before parent code
        // Call parent (required)
        Symfony.Bundle.AdminBundle.defaultList.superclass.initComponent.apply(this, arguments);
        // After parent code
        // e.g. install event handlers on rendered component
    },

    // Override other inherited methods 
    onRender: function(){
        // Before parent code
        // Call parent (required)
        Symfony.Bundle.AdminBundle.defaultList.superclass.onRender.apply(this, arguments);
        // After parent code
        
    }
});

Symfony.Bundle.AdminBundle.ObjectRef = Ext.extend(Ext.form.ComboBox,{
    initComponent: function(){

        /*var data = this.node.attributes.data;
        var fields = [];
        var columns = [];
        var formFields = [];
        for (var obj in data){
            fields.push(obj);
            var tmp = {
                header: obj
                ,dataIndex: obj
                ,sortable: true
            };

            var o = data[obj];
            o.fieldLabel = obj;
            o.name = obj;

            if(o.type=='ref') {
                o.xtype = 'objref';
            }
            
            
            if(obj=='id') {
                tmp.width=20;
                columns.unshift(tmp);
                o.disabled = true;
                formFields.unshift(o);
            } else {
                columns.push(tmp);
                formFields.push(o);
            }
        }*/
        var self = this;

        var col = null;
        for(col in self.targetToSourceKeyColumns) {
            break;
        }

        this.hiddenName = this.name;
        this.valueField = col;
        /*if(this['link']) {
            this.valueField = this['link'];
        }*/


        var fields = [];
        if(typeof entityMap[this['targetEntity']] == 'undefined') {
            throw "Could not find target entity "+this['targetEntity'];
        }
        for (var obj in entityMap[this['targetEntity']]){
            fields.push(obj);
        }
        
        var store = new Ext.data.JsonStore({
            url: 'admin/getData/'+escape(this['targetEntity'])
            ,root: 'objects'
            ,totalProperty: 'total'
            ,fields: [self.valueField, 'name']
            ,baseParams: {
                start:0
                ,limit:Symfony.Bundle.AdminBundle.pageSize
            }
        });
        //store.load({params:{start:0, limit:30}});
        store.load({params:{start:0, limit:Symfony.Bundle.AdminBundle.pageSize}});
        // Config object has already been applied to 'this' so properties can 
        // be overriden here or new properties (e.g. items, tools, buttons) 
        // can be added, eg:
        Ext.apply(this, {
            store: store
            ,triggerAction: 'all'
            ,mode: 'remote'
            ,displayField: 'name'
            ,pageSize: Symfony.Bundle.AdminBundle.pageSize
            ,minChars: 2
            /*typeAhead: true,
            triggerAction: 'all',
            lazyRender:true,
            mode: 'local',
            store: new Ext.data.ArrayStore({
                id: 0,
                fields: [
                    'myId',
                    'displayText'
                ],
                data: [[1, 'item1'], [2, 'item2']]
            }),
            valueField: 'myId',
            displayField: 'displayText'*/
        });
        Symfony.Bundle.AdminBundle.ObjectRef.superclass.initComponent.apply(this, arguments);
    }
    
});

Ext.reg('objref', Symfony.Bundle.AdminBundle.ObjectRef);
